// Simple follow the mouse script

var divId = 'mousepopup'; // div that is to follow the mouse
                       // (must be position:absolute)
var offX = 0;          // X offset from mouse position
var offY = 25;          // Y offset from mouse position

function mouseX(evt)
{
    if (!evt)
        evt = window.event;
    if (evt.pageX)
        return evt.pageX;
    else if (evt.clientX)
        return evt.clientX + (document.documentElement.scrollLeft ?  document.documentElement.scrollLeft : document.body.scrollLeft); 
    else
        return 0;
}

function mouseY(evt) 
{
    if (!evt)
        evt = window.event;
    if (evt.pageY)
        return evt.pageY;
    else if (evt.clientY)
        return evt.clientY + (document.documentElement.scrollTop ? document.documentElement.scrollTop : document.body.scrollTop);
    else
        return 0;
}

function follow()
{
    var div = document.getElementById(divId);
    offX = -div.offsetWidth/2;
    var left = (parseInt(mouseX(event))+offX);
    var top = (parseInt(mouseY(event))+offY);
    
    //make sure we dont pass the bottom of the gadget...
    var height = document.body.style.height.substring(0,document.body.style.height.length-2);
    if(top+div.offsetHeight > height)
        top = top - offY - div.offsetHeight - 5;//top = height-div.offsetHeight;
    
    //make sure we dont pass the right side of the gadget...
    var width = document.body.style.width.substring(0,document.body.style.width.length-2);
    if(left+div.offsetWidth > width)
        left = width-div.offsetWidth;
        
    //make sure we dont pass the left side of the gadget...
    if(left < 0)
        left = 0;
    
    div.style.left = left + 'px';
    div.style.top = top + 'px';
}

function showPopup(text)
{
    var div = document.getElementById(divId);
    div.style.display = 'block';
    div.style.color = getSetting("ShowTitleColor",defaultShowTitleColor);
    div.innerText = text; 
    follow();  
}

function hidePopup()
{
    var div = document.getElementById(divId);
    div.style.display = "none";
    div.innerText = "x";   
}

document.onmousemove = follow;
                    