
var fadeFontSize = 16;

document.onreadystatechange = function()
{
	if(document.readyState == "complete")
	{
		try 
		{
			// Gadget code
			System.Gadget.settingsUI = "settings.html";
			System.Gadget.onSettingsClosed = SettingsClosed;
		}
		catch(err)
		{
		}
		init();
	}
}

function init()
{
     dockStateChanged();
}

// Declare the dock and undock event handlers.
System.Gadget.onDock = dockStateChanged;
System.Gadget.onUndock = dockStateChanged;

// called when the docked state changes
function dockStateChanged()
{
	var root = document.getElementById("rootdiv");
	//Remove all child nodes (icons)
	if ( root.hasChildNodes() )
    {
        while ( root.firstChild )
        {
            root.removeChild(root.firstChild);       
        } 
    }
    
    generateRemoteControlIcons(root,getSetting('ShortcutPath',defaultShortcutPath)); 
    
    setSize();
}

function setSize()
{

                            // +1 to make space for description pop-up
    var calculatedheight = (linkcount+1)*(parseInt(getSetting('IconSize',defaultIconSize))+2*parseInt(getSetting('IconMargin',defaultIconMargin)));
        
    if (System.Gadget.docked)
    {
        document.body.style.width = "130px";
        document.body.style.height = calculatedheight+"px";
    } 
    else 
    {  
        document.body.style.width = "300px";
        document.body.style.height = calculatedheight+"px";
    }
}

var filesystem  = new ActiveXObject("Scripting.FileSystemObject"); 
var linkcount;

function generateRemoteControlIcons(element, folderpath)
{
    //Get windows path  
    var windowsPath = System.Shell.knownFolderPath("Windows");
	   
    linkcount = 0;
    var networkObject = new ActiveXObject("WScript.Network");
    var hostname = networkObject.ComputerName;
    
    //Loop trough folders    
	var folder = filesystem.GetFolder(folderpath);

    var files  = new Enumerator(folder.Files);	
    var machineNames = new Array();
    var i = 0;
    while(! files.atEnd())
    {
        if(endsWith(files.item().Name.toLowerCase(),".rdp"))
        {
            //Extract filename without extension
            machineNames[i] = files.item().Name.substring(0,files.item().Name.length-4);
    	 	
    	 	if(machineNames[i].toUpperCase() != hostname.toUpperCase())
    	 	{
	 	        //Title...
		        var font_name = document.createElement('font');
		        font_name.size = parseInt(getSetting("FontSize",defaultFontSize));
		        font_name.className = "machinenames";
		        font_name.innerText = machineNames[i];
		                		
                //Remotecontrol icon...
                var a_remote = document.createElement('a');
                a_remote.target = "_self";
                a_remote.href="#";
                a_remote.onclick=function(){FollowLink(encodeURI(folderpath+"\\"+this.firstChild.alt+".rdp"));};
                var img_remote = document.createElement('img');
                img_remote.border = 0;
                img_remote.alt = machineNames[i];
                if(getSetting("ShowTitle",defaultShowTitle) == "2")
                {
                    img_remote.onmouseover= function(){showPopup("Control "+this.alt);};
                    img_remote.onmouseout= function(){hidePopup()};
                }
                img_remote.style.margin = getSetting("IconMargin",defaultIconMargin);
                img_remote.src = "images\\remote_windows.gif";
                img_remote.width = getSetting("IconSize",defaultIconSize);
                img_remote.height = getSetting("IconSize",defaultIconSize);
                a_remote.appendChild(img_remote);
                
                //Restart icon...
                var a_restart = document.createElement('a');
                a_restart.target = "_self";
                a_restart.href="#";
                a_restart.onclick=function(){FollowLink(encodeURI(windowsPath +'\\system32\\shutdown.exe'),encodeURI(' -r -f -m \\\\'+this.firstChild.alt+' -t 0'),encodeURI(windowsPath +'\\system32\\'));};
                var img_restart = document.createElement('img');
                img_restart.border = 0;
                img_restart.alt = machineNames[i];
                if(getSetting("ShowTitle",defaultShowTitle) == "2")
                {
                    img_restart.onmouseover= function(){showPopup("Restart "+this.alt);};
                    img_restart.onmouseout= function(){hidePopup()};
                }
                img_restart.style.margin = getSetting("IconMargin",defaultIconMargin);
                img_restart.src = "images\\restart.gif";
                img_restart.width = getSetting("IconSize",defaultIconSize);
                img_restart.height = getSetting("IconSize",defaultIconSize);
                a_restart.appendChild(img_restart);
                
                //Shutdown icon...
                var a_shutdown = document.createElement('a');
                a_shutdown.target = "_self";
                a_shutdown.href = "#";
                a_shutdown.onclick=function(){FollowLink(encodeURI(windowsPath +'\\system32\\shutdown.exe'),encodeURI(' -s -f -m \\\\'+this.firstChild.alt+' -t 0'),encodeURI(windowsPath +'\\system32\\'));};
                var img_shutdown = document.createElement('img');
                img_shutdown.border = 0;
                img_shutdown.alt = machineNames[i];
                if(getSetting("ShowTitle",defaultShowTitle) == "2")
                {
                    img_shutdown.onmouseover= function(){showPopup("Shutdown "+this.alt);};
                    img_shutdown.onmouseout= function(){hidePopup()};
                }
                img_shutdown.style.margin = getSetting("IconMargin",defaultIconMargin);
                img_shutdown.src = "images\\shutdown.gif";
                img_shutdown.width = getSetting("IconSize",defaultIconSize);
                img_shutdown.height = getSetting("IconSize",defaultIconSize);
                a_shutdown.appendChild(img_shutdown);
                	
		        element.appendChild(font_name);
		        element.appendChild(a_remote);
		        element.appendChild(a_restart);
		        element.appendChild(a_shutdown);
                element.appendChild(document.createElement('br'));	   
                
                linkcount++;
                i++;
            }
	    }
	    files.moveNext();
    } 
}

function GetMachineName(fileName)
{
    return fileName.substring(0,fileName.length-4);
}

function FollowLink(file, args, dir)
{
	System.Shell.execute(decodeURI(file), decodeURI(args), decodeURI(dir));
	event.returnValue = false;
	return false;
}

function SettingsClosed(event) {
    // User hits OK on the settings page.
    if (event.closeAction == event.Action.commit)
    {
		init();
    }
    // User hits Cancel on the settings page.
    else if (event.closeAction == event.Action.cancel)
    {
    	
    }
}